# Copyright (C) 2010-2011 Richard Lincoln
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to
# deal in the Software without restriction, including without limitation the
# rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
# sell copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.

"""Contains only diagrams to be discussed with WG13, for consolidating T&amp;D models.
"""

from CIM14.IEC61968.WiresExt.TransformerBank import TransformerBank
from CIM14.IEC61968.WiresExt.PhaseImpedanceData import PhaseImpedanceData
from CIM14.IEC61968.WiresExt.DistributionTapChanger import DistributionTapChanger
from CIM14.IEC61968.WiresExt.PerLengthPhaseImpedance import PerLengthPhaseImpedance
from CIM14.IEC61968.WiresExt.PerLengthSequenceImpedance import PerLengthSequenceImpedance
from CIM14.IEC61968.WiresExt.WindingPiImpedance import WindingPiImpedance
from CIM14.IEC61968.WiresExt.DistributionLineSegment import DistributionLineSegment
from CIM14.IEC61968.WiresExt.DistributionTransformer import DistributionTransformer
from CIM14.IEC61968.WiresExt.DistributionTransformerWinding import DistributionTransformerWinding

nsURI = "http://iec.ch/TC57/2009/CIM-schema-cim14#WiresExt"
nsPrefix = "cimWiresExt"

